## ros-one-mbf-costmap-nav 0.4.0-42jammy.20251023.1533

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(mbf_costmap_nav)

set(CMAKE_CXX_STANDARD 17)

find_package(catkin REQUIRED
  COMPONENTS
  angles
  costmap_2d
  dynamic_reconfigure
  geometry_msgs
  mbf_abstract_nav
  mbf_costmap_core
  mbf_msgs
  mbf_utility
  nav_core
  nav_msgs
  roscpp
  std_msgs
  std_srvs
  tf
)

find_package(Boost COMPONENTS thread chrono REQUIRED)

# dynamic reconfigure
generate_dynamic_reconfigure_options(
  cfg/MoveBaseFlex.cfg
)

set(MBF_NAV_CORE_WRAPPER_LIB mbf_nav_core_wrapper)
set(MBF_COSTMAP_2D_SERVER_LIB mbf_costmap_server)
set(MBF_COSTMAP_2D_SERVER_NODE mbf_costmap_nav)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${MBF_COSTMAP_2D_SERVER_LIB}
  CATKIN_DEPENDS
  actionlib
  actionlib_msgs
  angles
  costmap_2d
  dynamic_reconfigure
  geometry_msgs
  mbf_abstract_nav
  mbf_costmap_core
  mbf_msgs
  mbf_utility
  nav_core
  nav_msgs
  pluginlib
  roscpp
  std_msgs
  std_srvs
  tf
  DEPENDS Boost
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

add_library(${MBF_NAV_CORE_WRAPPER_LIB}
  src/nav_core_wrapper/wrapper_global_planner.cpp
  src/nav_core_wrapper/wrapper_local_planner.cpp
  src/nav_core_wrapper/wrapper_recovery_behavior.cpp
)
add_dependencies(${MBF_NAV_CORE_WRAPPER_LIB} ${catkin_EXPORTED_TARGETS})
target_link_libraries(${MBF_NAV_CORE_WRAPPER_LIB}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_library(${MBF_COSTMAP_2D_SERVER_LIB}
  src/mbf_costmap_nav/costmap_navigation_server.cpp
  src/mbf_costmap_nav/costmap_planner_execution.cpp
  src/mbf_costmap_nav/costmap_controller_execution.cpp
  src/mbf_costmap_nav/costmap_recovery_execution.cpp
  src/mbf_costmap_nav/costmap_wrapper.cpp
  src/mbf_costmap_nav/footprint_helper.cpp
  src/mbf_costmap_nav/free_pose_search.cpp
  src/mbf_costmap_nav/free_pose_search_viz.cpp
)
add_dependencies(${MBF_COSTMAP_2D_SERVER_LIB} ${catkin_EXPORTED_TARGETS})
add_dependencies(${MBF_COSTMAP_2D_SERVER_LIB} ${MBF_NAV_CORE_WRAPPER_LIB})
add_dependencies(${MBF_COSTMAP_2D_SERVER_LIB} ${PROJECT_NAME}_gencfg)

target_link_libraries(${MBF_COSTMAP_2D_SERVER_LIB}
  ${MBF_NAV_CORE_WRAPPER_LIB}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_executable(${MBF_COSTMAP_2D_SERVER_NODE} src/move_base_server_node.cpp)
add_dependencies(${MBF_COSTMAP_2D_SERVER_NODE} ${MBF_COSTMAP_2D_SERVER_LIB})
target_link_libraries(${MBF_COSTMAP_2D_SERVER_NODE}
  ${MBF_COSTMAP_2D_SERVER_LIB}
  ${catkin_LIBRARIES}
)

install(TARGETS
  ${MBF_NAV_CORE_WRAPPER_LIB} ${MBF_COSTMAP_2D_SERVER_LIB} ${MBF_COSTMAP_2D_SERVER_NODE}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

catkin_install_python(PROGRAMS scripts/move_base_legacy_relay.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

#############
## Test    ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  find_package(map_server REQUIRED)

  add_rostest_gtest(free_pose_search_test
    test/free_pose_search.test
    test/free_pose_search_test.cpp
  )
  target_link_libraries(free_pose_search_test
    ${MBF_COSTMAP_2D_SERVER_LIB}
  )
endif()

=== debian/changelog ===
ros-one-mbf-costmap-nav (0.4.0-42jammy.20251023.1533) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 23 Oct 2025 15:33:51 +0000

ros-one-mbf-costmap-nav (0.4.0-0jammy) jammy; urgency=high

  * make the costmaps used for planning and controlling configurable, see #278
  * return empty footprint if partly outside of the map, see #272
  * add tf_transform_ptr to the abstract planner execution, see #256
  * transform pose to global frame before calling planner in costmap planner execution, see #256

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 26 Oct 2021 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.4-0jammy) jammy; urgency=high

  * fix blind driving, see #243

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 02 Dec 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.3-0jammy) jammy; urgency=high

  * Fix controller fails if robot pose gets older than tf_timeout, see #231
  * clear the costmap before deactivating it, see #220
  * Use catkin_install_python to install legacy relay. see #219
  * For move_base_legacy_relay, keep configured base local and global planners to send to MBF, see #209
  * Fix deallocation on shutdown by discarding all plugins and resetting action server pointers, see #199
  * Make reference symbol position consistent across the project, see #198
  * Move RobotInformation to mbf_utility, as it can be used generaly, see #196
  * Prevent unrelated type casts for Cell, see #197

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 05 Nov 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.2-0jammy) jammy; urgency=high

  * Remove dependency on base_local_planner and move FootprintHelper class to mbf_costmap_nav and make it static

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 25 May 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.1-0jammy) jammy; urgency=high

  * Ensure that check_costmap_mutex is destroyed after timer.
  * Avoid crash on shutdown by stop shutdown_costmap_timer on destructor
    and explicitly call the costmap_nav_srv destructor

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 07 Apr 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.0-0jammy) jammy; urgency=high

  * add output for cancel method if nav_core plugin is wrapped
  * unify license declaration to BSD-3

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 31 Mar 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.5-0jammy) jammy; urgency=high

  * Add clear_on_shutdown functionality
  * Do not pass boost functions to abstract server to (de)activate costmaps.
    Run instead abstract methods (possibly) overridden in the costmap server,
    all costmap-related handling refactored to a new CostmapWrapper class
  * On controller execution, check that local costmap is current

 -- Sebastian Pütz <spuetz@uos.de>  Fri, 11 Oct 2019 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.4-0jammy) jammy; urgency=high

  * Add check_point_cost service
  * Lock costmaps on clear_costmaps service
  * Replace recursive mutexes with normal ones when not needed

 -- Sebastian Pütz <spuetz@uos.de>  Sun, 16 Jun 2019 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.3-0jammy) jammy; urgency=high

  * single publisher for controller execution objects

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 14 Nov 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.2-0jammy) jammy; urgency=high

  * Do not use MultiThreadedSpinner, as costmap updates can crash when combining laser scans and point clouds
  * Make start/stop costmaps mutexed, since concurrent calls to start can lead to segfaults

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 10 Oct 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.1-0jammy) jammy; urgency=high

  * Make MBF melodic and indigo compatible
  * Fix GoalHandle references bug in callbacks

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 03 Oct 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.0-0jammy) jammy; urgency=high

  * Update copyright and 3-clause-BSD license
  * Concurrency for planners, controllers and recovery behaviors

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 11 Sep 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.1.0-0jammy) jammy; urgency=high

  * First release of move_base_flex for kinetic and lunar

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 22 Mar 2018 00:00:00 -0000

=== debian/control ===
Source: ros-one-mbf-costmap-nav
Section: misc
Priority: optional
Maintainer: Sebastian Pütz <spuetz@uos.de>
Build-Depends: debhelper (>= 9.0.0), ros-one-actionlib, ros-one-actionlib-msgs, ros-one-angles, ros-one-catkin, ros-one-costmap-2d, ros-one-dynamic-reconfigure, ros-one-geometry-msgs, ros-one-mbf-abstract-nav, ros-one-mbf-costmap-core, ros-one-mbf-msgs, ros-one-mbf-utility, ros-one-nav-core, ros-one-nav-msgs, ros-one-pluginlib, ros-one-roscpp, ros-one-std-msgs, ros-one-std-srvs, ros-one-tf
Homepage: http://wiki.ros.org/move_base_flex
Standards-Version: 3.9.2

Package: ros-one-mbf-costmap-nav
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-actionlib, ros-one-actionlib-msgs, ros-one-angles, ros-one-costmap-2d, ros-one-dynamic-reconfigure, ros-one-geometry-msgs, ros-one-mbf-abstract-nav, ros-one-mbf-costmap-core, ros-one-mbf-msgs, ros-one-mbf-utility, ros-one-move-base, ros-one-move-base-msgs, ros-one-nav-core, ros-one-nav-msgs, ros-one-pluginlib, ros-one-roscpp, ros-one-std-msgs, ros-one-std-srvs, ros-one-tf
Description: The mbf_costmap_nav package contains the costmap navigation server implementation of Move Base Flex (MBF).
 The costmap navigation server is bound to the costmap_2d representation. It provides the Actions for planning, controlling and recovering. At the time of start MBF loads all defined plugins. Therefor, it loads all plugins which are defined in the lists *planners*, *controllers* and *recovery_behaviors*. Each list holds a pair of a *name* and a *type*. The *type* defines which kind of plugin to load. The *name* defines under which name the plugin should be callable by the actions. Additionally the mbf_costmap_nav package comes with a wrapper for the old navigation stack and the plugins which inherits from the nav_core base classes. Preferably it tries to load plugins for the new API. However, plugins could even support both move_base and move_base_flex by inheriting both base class interfaces located in the nav_core package and in the mbf_costmap_core package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-mbf-costmap-nav//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-mbf-costmap-nav 0.4.0-42jammy.20251208.0833

=== debian/changelog ===
ros-one-mbf-costmap-nav (0.4.0-42jammy.20251208.0833) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 08 Dec 2025 08:33:51 +0000

## ros-one-mbf-costmap-nav 0.4.0-42jammy.20260222.0123

=== debian/changelog ===
ros-one-mbf-costmap-nav (0.4.0-42jammy.20260222.0123) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Sebastian Pütz <spuetz@uos.de>  Sun, 22 Feb 2026 01:23:38 +0000

## ros-one-mbf-costmap-nav 0.4.0-42noble.20251023.1608

=== debian/changelog ===
ros-one-mbf-costmap-nav (0.4.0-42noble.20251023.1608) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 23 Oct 2025 16:08:18 +0000

ros-one-mbf-costmap-nav (0.4.0-0noble) noble; urgency=high

  * make the costmaps used for planning and controlling configurable, see #278
  * return empty footprint if partly outside of the map, see #272
  * add tf_transform_ptr to the abstract planner execution, see #256
  * transform pose to global frame before calling planner in costmap planner execution, see #256

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 26 Oct 2021 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.4-0noble) noble; urgency=high

  * fix blind driving, see #243

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 02 Dec 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.3-0noble) noble; urgency=high

  * Fix controller fails if robot pose gets older than tf_timeout, see #231
  * clear the costmap before deactivating it, see #220
  * Use catkin_install_python to install legacy relay. see #219
  * For move_base_legacy_relay, keep configured base local and global planners to send to MBF, see #209
  * Fix deallocation on shutdown by discarding all plugins and resetting action server pointers, see #199
  * Make reference symbol position consistent across the project, see #198
  * Move RobotInformation to mbf_utility, as it can be used generaly, see #196
  * Prevent unrelated type casts for Cell, see #197

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 05 Nov 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.2-0noble) noble; urgency=high

  * Remove dependency on base_local_planner and move FootprintHelper class to mbf_costmap_nav and make it static

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 25 May 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.1-0noble) noble; urgency=high

  * Ensure that check_costmap_mutex is destroyed after timer.
  * Avoid crash on shutdown by stop shutdown_costmap_timer on destructor
    and explicitly call the costmap_nav_srv destructor

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 07 Apr 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.3.0-0noble) noble; urgency=high

  * add output for cancel method if nav_core plugin is wrapped
  * unify license declaration to BSD-3

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 31 Mar 2020 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.5-0noble) noble; urgency=high

  * Add clear_on_shutdown functionality
  * Do not pass boost functions to abstract server to (de)activate costmaps.
    Run instead abstract methods (possibly) overridden in the costmap server,
    all costmap-related handling refactored to a new CostmapWrapper class
  * On controller execution, check that local costmap is current

 -- Sebastian Pütz <spuetz@uos.de>  Fri, 11 Oct 2019 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.4-0noble) noble; urgency=high

  * Add check_point_cost service
  * Lock costmaps on clear_costmaps service
  * Replace recursive mutexes with normal ones when not needed

 -- Sebastian Pütz <spuetz@uos.de>  Sun, 16 Jun 2019 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.3-0noble) noble; urgency=high

  * single publisher for controller execution objects

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 14 Nov 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.2-0noble) noble; urgency=high

  * Do not use MultiThreadedSpinner, as costmap updates can crash when combining laser scans and point clouds
  * Make start/stop costmaps mutexed, since concurrent calls to start can lead to segfaults

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 10 Oct 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.1-0noble) noble; urgency=high

  * Make MBF melodic and indigo compatible
  * Fix GoalHandle references bug in callbacks

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 03 Oct 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.2.0-0noble) noble; urgency=high

  * Update copyright and 3-clause-BSD license
  * Concurrency for planners, controllers and recovery behaviors

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 11 Sep 2018 00:00:00 -0000

ros-one-mbf-costmap-nav (0.1.0-0noble) noble; urgency=high

  * First release of move_base_flex for kinetic and lunar

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 22 Mar 2018 00:00:00 -0000

## ros-one-mbf-costmap-nav 0.4.0-42noble.20251208.1507

=== debian/changelog ===
ros-one-mbf-costmap-nav (0.4.0-42noble.20251208.1507) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 08 Dec 2025 15:07:13 +0000

## ros-one-mbf-costmap-nav 0.4.0-42noble.20260222.2152

=== debian/changelog ===
ros-one-mbf-costmap-nav (0.4.0-42noble.20260222.2152) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Sebastian Pütz <spuetz@uos.de>  Sun, 22 Feb 2026 21:52:47 +0000
